/**
 * Language API
 * OCI Language Service solutions can help enterprise customers integrate AI into their products immediately using our proven,
    pre-trained and custom models or containers, without a need to set up an house team of AI and ML experts.
    This allows enterprises to focus on business drivers and development work rather than AI and ML operations, which shortens the time to market.

 * OpenAPI spec version: 20210101
 *
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2022, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
import * as BatchDetectDominantLanguageDetails from "./batch-detect-dominant-language-details";
export import BatchDetectDominantLanguageDetails = BatchDetectDominantLanguageDetails.BatchDetectDominantLanguageDetails;
import * as BatchDetectDominantLanguageResult from "./batch-detect-dominant-language-result";
export import BatchDetectDominantLanguageResult = BatchDetectDominantLanguageResult.BatchDetectDominantLanguageResult;
import * as BatchDetectLanguageEntitiesDetails from "./batch-detect-language-entities-details";
export import BatchDetectLanguageEntitiesDetails = BatchDetectLanguageEntitiesDetails.BatchDetectLanguageEntitiesDetails;
import * as BatchDetectLanguageEntitiesResult from "./batch-detect-language-entities-result";
export import BatchDetectLanguageEntitiesResult = BatchDetectLanguageEntitiesResult.BatchDetectLanguageEntitiesResult;
import * as BatchDetectLanguageKeyPhrasesDetails from "./batch-detect-language-key-phrases-details";
export import BatchDetectLanguageKeyPhrasesDetails = BatchDetectLanguageKeyPhrasesDetails.BatchDetectLanguageKeyPhrasesDetails;
import * as BatchDetectLanguageKeyPhrasesResult from "./batch-detect-language-key-phrases-result";
export import BatchDetectLanguageKeyPhrasesResult = BatchDetectLanguageKeyPhrasesResult.BatchDetectLanguageKeyPhrasesResult;
import * as BatchDetectLanguageSentimentsDetails from "./batch-detect-language-sentiments-details";
export import BatchDetectLanguageSentimentsDetails = BatchDetectLanguageSentimentsDetails.BatchDetectLanguageSentimentsDetails;
import * as BatchDetectLanguageSentimentsResult from "./batch-detect-language-sentiments-result";
export import BatchDetectLanguageSentimentsResult = BatchDetectLanguageSentimentsResult.BatchDetectLanguageSentimentsResult;
import * as BatchDetectLanguageTextClassificationDetails from "./batch-detect-language-text-classification-details";
export import BatchDetectLanguageTextClassificationDetails = BatchDetectLanguageTextClassificationDetails.BatchDetectLanguageTextClassificationDetails;
import * as BatchDetectLanguageTextClassificationResult from "./batch-detect-language-text-classification-result";
export import BatchDetectLanguageTextClassificationResult = BatchDetectLanguageTextClassificationResult.BatchDetectLanguageTextClassificationResult;
import * as DetectDominantLanguageDetails from "./detect-dominant-language-details";
export import DetectDominantLanguageDetails = DetectDominantLanguageDetails.DetectDominantLanguageDetails;
import * as DetectDominantLanguageResult from "./detect-dominant-language-result";
export import DetectDominantLanguageResult = DetectDominantLanguageResult.DetectDominantLanguageResult;
import * as DetectLanguageEntitiesDetails from "./detect-language-entities-details";
export import DetectLanguageEntitiesDetails = DetectLanguageEntitiesDetails.DetectLanguageEntitiesDetails;
import * as DetectLanguageEntitiesResult from "./detect-language-entities-result";
export import DetectLanguageEntitiesResult = DetectLanguageEntitiesResult.DetectLanguageEntitiesResult;
import * as DetectLanguageKeyPhrasesDetails from "./detect-language-key-phrases-details";
export import DetectLanguageKeyPhrasesDetails = DetectLanguageKeyPhrasesDetails.DetectLanguageKeyPhrasesDetails;
import * as DetectLanguageKeyPhrasesResult from "./detect-language-key-phrases-result";
export import DetectLanguageKeyPhrasesResult = DetectLanguageKeyPhrasesResult.DetectLanguageKeyPhrasesResult;
import * as DetectLanguageSentimentsDetails from "./detect-language-sentiments-details";
export import DetectLanguageSentimentsDetails = DetectLanguageSentimentsDetails.DetectLanguageSentimentsDetails;
import * as DetectLanguageSentimentsResult from "./detect-language-sentiments-result";
export import DetectLanguageSentimentsResult = DetectLanguageSentimentsResult.DetectLanguageSentimentsResult;
import * as DetectLanguageTextClassificationDetails from "./detect-language-text-classification-details";
export import DetectLanguageTextClassificationDetails = DetectLanguageTextClassificationDetails.DetectLanguageTextClassificationDetails;
import * as DetectLanguageTextClassificationResult from "./detect-language-text-classification-result";
export import DetectLanguageTextClassificationResult = DetectLanguageTextClassificationResult.DetectLanguageTextClassificationResult;
import * as DetectedLanguage from "./detected-language";
export import DetectedLanguage = DetectedLanguage.DetectedLanguage;
import * as DocumentError from "./document-error";
export import DocumentError = DocumentError.DocumentError;
import * as DominantLanguageDocument from "./dominant-language-document";
export import DominantLanguageDocument = DominantLanguageDocument.DominantLanguageDocument;
import * as DominantLanguageDocumentResult from "./dominant-language-document-result";
export import DominantLanguageDocumentResult = DominantLanguageDocumentResult.DominantLanguageDocumentResult;
import * as Entity from "./entity";
export import Entity = Entity.Entity;
import * as EntityDocument from "./entity-document";
export import EntityDocument = EntityDocument.EntityDocument;
import * as EntityDocumentResult from "./entity-document-result";
export import EntityDocumentResult = EntityDocumentResult.EntityDocumentResult;
import * as ErrorDetails from "./error-details";
export import ErrorDetails = ErrorDetails.ErrorDetails;
import * as HierarchicalEntity from "./hierarchical-entity";
export import HierarchicalEntity = HierarchicalEntity.HierarchicalEntity;
import * as KeyPhrase from "./key-phrase";
export import KeyPhrase = KeyPhrase.KeyPhrase;
import * as KeyPhraseDocument from "./key-phrase-document";
export import KeyPhraseDocument = KeyPhraseDocument.KeyPhraseDocument;
import * as KeyPhraseDocumentResult from "./key-phrase-document-result";
export import KeyPhraseDocumentResult = KeyPhraseDocumentResult.KeyPhraseDocumentResult;
import * as NerModelVersion from "./ner-model-version";
export import NerModelVersion = NerModelVersion.NerModelVersion;
import * as SentimentAspect from "./sentiment-aspect";
export import SentimentAspect = SentimentAspect.SentimentAspect;
import * as SentimentDocumentResult from "./sentiment-document-result";
export import SentimentDocumentResult = SentimentDocumentResult.SentimentDocumentResult;
import * as SentimentSentence from "./sentiment-sentence";
export import SentimentSentence = SentimentSentence.SentimentSentence;
import * as SentimentsDocument from "./sentiments-document";
export import SentimentsDocument = SentimentsDocument.SentimentsDocument;
import * as TextClassification from "./text-classification";
export import TextClassification = TextClassification.TextClassification;
import * as TextClassificationDocument from "./text-classification-document";
export import TextClassificationDocument = TextClassificationDocument.TextClassificationDocument;
import * as TextClassificationDocumentResult from "./text-classification-document-result";
export import TextClassificationDocumentResult = TextClassificationDocumentResult.TextClassificationDocumentResult;
