/**
 * Database Migration API
 * Use the Oracle Cloud Infrastructure Database Migration APIs to perform database migration operations.
 * OpenAPI spec version: 20210929
 *
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2022, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
import * as model from "../model";
/**
 * Migration resource
 *
 */
export interface MigrationSummary {
    /**
     * The OCID of the resource
     *
     */
    "id": string;
    /**
     * Migration Display Name
     *
     */
    "displayName": string;
    /**
     * OCID of the compartment
     *
     */
    "compartmentId": string;
    /**
     * Migration type.
     *
     */
    "type": model.MigrationTypes;
    /**
     * The OCID of the Source Database Connection.
     *
     */
    "sourceDatabaseConnectionId": string;
    /**
     * The OCID of the Source Container Database Connection.
     *
     */
    "sourceContainerDatabaseConnectionId"?: string;
    /**
     * The OCID of the Target Database Connection.
     *
     */
    "targetDatabaseConnectionId": string;
    /**
     * OCID of the current ODMS Job in execution for the Migration, if any.
     *
     */
    "executingJobId"?: string;
    /**
     * The OCID of the registered on-premises ODMS Agent. Only valid for Offline Migrations.
     *
     */
    "agentId"?: string;
    "vaultDetails"?: model.VaultDetails;
    /**
     * The time the Migration was created. An RFC3339 formatted datetime string.
     *
     */
    "timeCreated": Date;
    /**
     * The time of the last Migration details update. An RFC3339 formatted datetime string.
     *
     */
    "timeUpdated"?: Date;
    /**
     * The time of last Migration. An RFC3339 formatted datetime string.
     *
     */
    "timeLastMigration"?: Date;
    /**
     * The current state of the Migration.
     *
     */
    "lifecycleState": model.MigrationLifecycleStates;
    /**
     * Additional status related to the execution and current state of the Migration.
     *
     */
    "lifecycleDetails"?: model.MigrationStatus;
    /**
     * Simple key-value pair that is applied without any predefined name, type or scope. Exists for cross-compatibility only.
     * Example: `{\"bar-key\": \"value\"}`
     *
     */
    "freeformTags"?: {
        [key: string]: string;
    };
    /**
     * Defined tags for this resource. Each key is predefined and scoped to a namespace.
     * Example: `{\"foo-namespace\": {\"bar-key\": \"value\"}}`
     *
     */
    "definedTags"?: {
        [key: string]: {
            [key: string]: any;
        };
    };
    /**
     * Usage of system tag keys. These predefined keys are scoped to namespaces.
     * Example: `{\"orcl-cloud\": {\"free-tier-retained\": \"true\"}}`
     *
     */
    "systemTags"?: {
        [key: string]: {
            [key: string]: any;
        };
    };
}
export declare namespace MigrationSummary {
    function getJsonObj(obj: MigrationSummary): object;
    function getDeserializedJsonObj(obj: MigrationSummary): object;
}
