"use strict";
/**
 * Data Connectivity Management API
 * Use the DCMS APIs to perform Metadata/Data operations.
 * OpenAPI spec version: 20210217
 * Contact: di_dcms_dev_ww_grp@oracle.com
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2022, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.EntityShape = void 0;
const model = __importStar(require("../model"));
const common = require("oci-common");
var EntityShape;
(function (EntityShape) {
    function getJsonObj(obj) {
        const jsonObj = Object.assign(Object.assign({}, obj), {
            "metadata": obj.metadata ? model.ObjectMetadata.getJsonObj(obj.metadata) : undefined
        });
        if (obj && "modelType" in obj && obj.modelType) {
            switch (obj.modelType) {
                case "DATA_STORE_ENTITY":
                    return model.EntityShapeFromDataStore.getJsonObj(jsonObj, true);
                case "TABLE_ENTITY":
                    return model.EntityShapeFromTable.getJsonObj(jsonObj, true);
                case "SQL_ENTITY":
                    return model.EntityShapeFromSQL.getJsonObj(jsonObj, true);
                case "VIEW_ENTITY":
                    return model.EntityShapeFromView.getJsonObj(jsonObj, true);
                case "FILE_ENTITY":
                    return model.EntityShapeFromFile.getJsonObj(jsonObj, true);
                default:
                    if (common.LOG.logger)
                        common.LOG.logger.info(`Unknown value for: ${obj.modelType}`);
            }
        }
        return jsonObj;
    }
    EntityShape.getJsonObj = getJsonObj;
    function getDeserializedJsonObj(obj) {
        const jsonObj = Object.assign(Object.assign({}, obj), {
            "metadata": obj.metadata
                ? model.ObjectMetadata.getDeserializedJsonObj(obj.metadata)
                : undefined
        });
        if (obj && "modelType" in obj && obj.modelType) {
            switch (obj.modelType) {
                case "DATA_STORE_ENTITY":
                    return model.EntityShapeFromDataStore.getDeserializedJsonObj(jsonObj, true);
                case "TABLE_ENTITY":
                    return model.EntityShapeFromTable.getDeserializedJsonObj(jsonObj, true);
                case "SQL_ENTITY":
                    return model.EntityShapeFromSQL.getDeserializedJsonObj(jsonObj, true);
                case "VIEW_ENTITY":
                    return model.EntityShapeFromView.getDeserializedJsonObj(jsonObj, true);
                case "FILE_ENTITY":
                    return model.EntityShapeFromFile.getDeserializedJsonObj(jsonObj, true);
                default:
                    if (common.LOG.logger)
                        common.LOG.logger.info(`Unknown value for: ${obj.modelType}`);
            }
        }
        return jsonObj;
    }
    EntityShape.getDeserializedJsonObj = getDeserializedJsonObj;
})(EntityShape = exports.EntityShape || (exports.EntityShape = {}));
//# sourceMappingURL=entity-shape.js.map