/**
 * Data Connectivity Management API
 * Use the DCMS APIs to perform Metadata/Data operations.
 * OpenAPI spec version: 20210217
 * Contact: di_dcms_dev_ww_grp@oracle.com
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2022, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
import * as model from "../model";
/**
 * Properties used in connection update operations.
 */
export interface UpdateConnectionDetails {
    /**
     * The model version of an object.
     */
    "modelVersion"?: string;
    /**
     * The type of the object.
     */
    "modelType"?: string;
    /**
     * Free form text without any restriction on permitted characters. Name can have letters, numbers, and special characters. The value is editable and is restricted to 1000 characters.
     */
    "name"?: string;
    /**
     * User-defined description for the connection.
     */
    "description"?: string;
    /**
     * The version of the object that is used to track changes in the object instance. Note: Numbers greater than Number.MAX_SAFE_INTEGER will result in rounding issues.
     */
    "objectVersion"?: number;
    /**
     * The status of an object that can be set to value 1 for shallow references across objects, other values reserved. Note: Numbers greater than Number.MAX_SAFE_INTEGER will result in rounding issues.
     */
    "objectStatus"?: number;
    /**
     * Value can only contain upper case letters, underscore, and numbers. It should begin with upper case letter or underscore. The value can be modified.
     */
    "identifier"?: string;
    "primarySchema"?: model.Schema;
    /**
     * The properties for the connection.
     */
    "connectionProperties"?: Array<model.ConnectionProperty>;
    /**
     * All the properties for the connection in a key-value map format.
     */
    "properties": {
        [key: string]: any;
    };
    /**
     * Specific Connection Type
     */
    "type": string;
    /**
     * The default property for the connection.
     */
    "isDefault"?: boolean;
    "metadata"?: model.ObjectMetadata;
    "registryMetadata"?: model.RegistryMetadata;
}
export declare namespace UpdateConnectionDetails {
    function getJsonObj(obj: UpdateConnectionDetails): object;
    function getDeserializedJsonObj(obj: UpdateConnectionDetails): object;
}
